#include "CallRet.h"
#include "main.h"

void call()
{
	Stack[SPtr] = PC+3;
	SPtr++;
	if (SPtr >= STACKSIZE) SPtr = 0;
	PC = memory(PC+1) | memory(PC+2) << 8;
}

void cnc()
{
	if (!Cflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >= STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;
}

void cnz()
{
	if (!Zflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cc()
{
	if (Cflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cz()
{
	if (Zflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cpo()
{
	if (!Pflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cpe()
{
	if (Pflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cp()
{
	if (!Sflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void cm()
{
	if (Sflag) {
		Stack[SPtr] = PC+3;
		SPtr++;
		if (SPtr >=STACKSIZE) SPtr = 0;
		PC = memory(PC+1) | memory(PC+2) << 8;
	}
	else	PC += 3;

}

void ret()
{
	SPtr--;
	if (SPtr<0) SPtr=STACKSIZE - 1;
	PC = Stack[SPtr];
}

void rnc()
{
	if (!Cflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rnz()
{
	if (!Zflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rc()
{
	if (Cflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rz()
{
	if (Zflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rpo()
{
	if (!Pflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rpe()
{
	if (Pflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rp()
{
	if (!Sflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rm()
{
	if (Sflag) {
		SPtr--;
		if (SPtr<0) SPtr=STACKSIZE - 1;
		PC = Stack[SPtr];
	}
	else PC++;
}

void rst0()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 0;
}

void rst1()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 8;
}

void rst2()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 16;
}

void rst3()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 24;
}

void rst4()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 32;
}

void rst5()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 40;
}

void rst6()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 48;
}

void rst7()
{
	Stack[SPtr] = PC+1;
	SPtr++;
	if (SPtr >=STACKSIZE) SPtr = 0;
	PC = 56;
}
