#include "Aritm.h"
#include "main.h"

void adi()
{
uint16_t x;
	Areg = x = Areg + memory(PC+1);
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC += 2;
}

void adci()
{
uint16_t x;
	Areg = x = Areg + memory(PC+1) + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC += 2;
}

void sui()
{
uint16_t x;
	Areg = x = Areg - memory(PC+1);
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC += 2;
}

void sbi()
{
uint16_t x;
	Areg = x = Areg - memory(PC+1) - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC += 2;
}

void cpi()
{
uint16_t x;
	x = Areg - memory(PC+1);
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;	// mask to 1 Byte
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC += 2;
}

void add_a()
{
uint16_t x;
	Areg = x = Areg + Areg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_b()
{
uint16_t x;
	Areg = x = Areg + Breg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_c()
{
uint16_t x;
	Areg = x = Areg + Creg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_d()
{
uint16_t x;
	Areg = x = Areg + Dreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_e()
{
uint16_t x;
	Areg = x = Areg + Ereg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_h()
{
uint16_t x;
	Areg = x = Areg + Hreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_l()
{
uint16_t x;
	Areg = x = Areg + Lreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void add_m()
{
uint16_t x;
	Areg = x = Areg + Mem;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_a()
{
uint16_t x;
	Areg = x = Areg + Areg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_b()
{
uint16_t x;
	Areg = x = Areg + Breg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_c()
{
uint16_t x;
	Areg = x = Areg + Creg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_d()
{
uint16_t x;
	Areg = x = Areg + Dreg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_e()
{
uint16_t x;
	Areg = x = Areg + Ereg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_h()
{
uint16_t x;
	Areg = x = Areg + Hreg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_l()
{
uint16_t x;
	Areg = x = Areg + Lreg + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void adc_m()
{
uint16_t x;
	Areg = x = Areg + Mem + Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_a()
{
uint16_t x;
	Areg = x = Areg - Areg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_b()
{
uint16_t x;
	Areg = x = Areg - Breg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_c()
{
uint16_t x;
	Areg = x = Areg - Creg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_d()
{
uint16_t x;
	Areg = x = Areg - Dreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_e()
{
uint16_t x;
	Areg = x = Areg - Ereg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_h()
{
uint16_t x;
	Areg = x = Areg - Hreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_l()
{
uint16_t x;
	Areg = x = Areg - Lreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sub_m()
{
uint16_t x;
	Areg = x = Areg - Mem;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_a()
{
uint16_t x;
	Areg = x = Areg - Areg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_b()
{
uint16_t x;
	Areg = x = Areg - Breg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_c()
{
uint16_t x;
	Areg = x = Areg - Creg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_d()
{
uint16_t x;
	Areg = x = Areg - Dreg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_e()
{
uint16_t x;
	Areg = x = Areg - Ereg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_h()
{
uint16_t x;
	Areg = x = Areg - Hreg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_l()
{
uint16_t x;
	Areg = x = Areg - Lreg - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void sbc_m()
{
uint16_t x;
	Areg = x = Areg - Mem - Cflag;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	Zflag = !Areg;
	Sflag = Areg & 128;
	Pflag = pgm_read_byte(&parity[Areg]);
	PC++;
}

void cmp_a()
{
uint16_t x;
	x = Areg - Areg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_b()
{
uint16_t x;
	x = Areg - Breg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_c()
{
uint16_t x;
	x = Areg - Creg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_d()
{
uint16_t x;
	x = Areg - Dreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_e()
{
uint16_t x;
	x = Areg - Ereg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_h()
{
uint16_t x;
	x = Areg - Hreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_l()
{
uint16_t x;
	x = Areg - Lreg;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}

void cmp_m()
{
uint16_t x;
	x = Areg - Mem;
	Cflag = (x>>8) & 1;	// Bit 9 of x
	x = x & 255;
	Zflag = !x;
	Sflag = x & 128;
	Pflag = pgm_read_byte(&parity[x]);
	PC++;
}
