#include "Jump.h"
#include "main.h"

void jmp()
{
uint16_t x;
	x = memory(PC+1) | memory(PC+2)<<8;
	PC = x;
}
	
void jnc()	// not carry
{
uint16_t x;
	if (!Cflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jc()	// carry
{
uint16_t x;
	if (Cflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jnz()	// not zero
{
uint16_t x;
	if (!Zflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jz()	// zero
{
uint16_t x;
	if (Zflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jp()	// positive
{
uint16_t x;
	if (!Sflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jm()	// minus
{
uint16_t x;
	if (Sflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jpe()	// parity even
{
uint16_t x;
	if (Pflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}

void jpo()	// parity odd
{
uint16_t x;
	if (!Pflag) {
		x = memory(PC+1) | memory(PC+2)<<8;
	}
	else {
		x = PC+3;	
	}
	PC = x;
}


